#include "stdafx.h"

#include <pm.h>
#define SIZEOF(x) (sizeof(x)/sizeof(x[0]))

int MessageBoxF(HWND hParent, const TCHAR *title, UINT mask, const TCHAR *fmt,...)
{
	va_list va;
	TCHAR tszText[1024];

	va_start(va,fmt);
		_vsntprintf(tszText, SIZEOF(tszText),fmt,va);
		va_end(va);
		tszText[SIZEOF(tszText)-1] = 0;
	va_end(va);
	return MessageBox(hParent, tszText, title, mask);
}

const wchar_t* szAppTitle = L"tapCat";
const wchar_t* szAppTag   = L"tapCatClass";
const wchar_t* szAppAtom  = L"tapCat/Event";
const wchar_t* szAppReg   = L"ControlPanel\\Backlight";

HWND hMainWnd = NULL;
HINSTANCE hInst = NULL;
DWORD g_dwAcTimeout = 30;
DWORD g_dwBcTimeout = 30;
BOOL g_bAC = FALSE;

HANDLE g_hAtom = NULL;
HANDLE g_hQueue[2] = {NULL,NULL};

enum {
	EV_INACTIVE = 0,
	EV_ACTIVE,

	EV_COUNT
};
wchar_t* g_szHev[EV_COUNT] = {
	L"PowerManager/UserActivity_Inactive",
	L"PowerManager/UserActivity_Active"
};
wchar_t* g_szHevName[EV_COUNT] = {
	L"Inactivity",
	L"Activity",
};
HANDLE g_hev[EV_COUNT];

// GDI Escapes for ExtEscape()
#define QUERYESCSUPPORT    8
 
// The following are unique to CE
#define SETPOWERMANAGEMENT   6147
#define GETPOWERMANAGEMENT   6148
 
typedef enum _VIDEO_POWER_STATE {
    VideoPowerOn = 1,
    VideoPowerStandBy,
    VideoPowerSuspend,
    VideoPowerOff
} VIDEO_POWER_STATE, *PVIDEO_POWER_STATE;
 
typedef struct _VIDEO_POWER_MANAGEMENT {
    ULONG Length;
    ULONG DPMSVersion;
    ULONG PowerState;
} VIDEO_POWER_MANAGEMENT, *PVIDEO_POWER_MANAGEMENT;

void SwitchBacklight( _VIDEO_POWER_STATE state )
{
	HDC gdc;
	int iESC=SETPOWERMANAGEMENT;

	gdc = GetDC(NULL);
	if( ExtEscape( gdc, QUERYESCSUPPORT, sizeof(int), (LPCSTR)&iESC, 0, NULL ) != 0 ) {
		VIDEO_POWER_MANAGEMENT vpm;
		vpm.Length = sizeof(VIDEO_POWER_MANAGEMENT);
		vpm.DPMSVersion = 0x0001;
		vpm.PowerState = state;
		ExtEscape(gdc, SETPOWERMANAGEMENT, vpm.Length, (LPCSTR) &vpm, 0, NULL);
    }
	ReleaseDC(NULL, gdc);
    return;
}

enum {
	IDC_ACSTATUS = 110,
	IDC_ACTIMEOUT,
	IDC_BCSTATUS,
	IDC_BCTIMEOUT,
	IDC_APPLY,
	IDC_CANCEL,
	IDC_EXIT
};

const DWORD ctrlId[] = {
	IDC_ACSTATUS,
	IDC_ACTIMEOUT,
	IDC_BCSTATUS,
	IDC_BCTIMEOUT,
	IDC_APPLY,
	IDC_CANCEL,
	IDC_EXIT
};

const wchar_t* ctrlClass[] = {
	L"STATIC",
	TRACKBAR_CLASS,
	L"STATIC",
	TRACKBAR_CLASS,
	L"BUTTON",
	L"BUTTON",
	L"BUTTON"
};
const wchar_t* ctrlText[] = {
	NULL,
	NULL,
	NULL,
	NULL,
	L"Apply",
	L"Cancel",
	L"Exit"
};

void updateStatus( void )
{
	wchar_t szbuf[64];
	DWORD dw;

	dw = SendMessage( GetDlgItem( hMainWnd, IDC_ACTIMEOUT ), TBM_GETPOS, 0, 0 );
	_snwprintf( szbuf, SIZEOF(szbuf), L"Eclipse timeout (AC): %d s.", dw );
	SetDlgItemText( hMainWnd, IDC_ACSTATUS, szbuf );

	dw = SendMessage( GetDlgItem( hMainWnd, IDC_BCTIMEOUT ), TBM_GETPOS, 0, 0 );
	_snwprintf( szbuf, SIZEOF(szbuf), L"Eclipse timeout (Bat): %d s.", dw );
	SetDlgItemText( hMainWnd, IDC_BCSTATUS, szbuf );
}

void showSetup( BOOL bSetup )
{
	HWND ctrl = GetDlgItem( hMainWnd, IDC_ACTIMEOUT );
	SendMessage( ctrl, TBM_SETRANGE, FALSE, MAKELONG( 0, 240 ) );
	SendMessage( ctrl, TBM_SETPOS, TRUE, g_dwAcTimeout );

	ctrl = GetDlgItem( hMainWnd, IDC_BCTIMEOUT );
	SendMessage( ctrl, TBM_SETRANGE, FALSE, MAKELONG( 0, 240 ) );
	SendMessage( ctrl, TBM_SETPOS, TRUE, g_dwBcTimeout );

	updateStatus();
	for( int indx = 0, dy = 5; indx < SIZEOF(ctrlId); indx++ )
		ShowWindow( GetDlgItem( hMainWnd, ctrlId[indx]), bSetup?SW_SHOW:SW_HIDE );
}

void showWnd()
{
	ShowWindow( hMainWnd, SW_SHOW );
	UpdateWindow( hMainWnd );
	SetForegroundWindow( hMainWnd );
	SHFullScreen( hMainWnd, SHFS_HIDETASKBAR | SHFS_HIDESIPBUTTON );
}

void hideWnd( void )
{
	ShowWindow( hMainWnd, SW_HIDE );
	SwitchBacklight( VideoPowerOn );
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message) 
	{
		case WM_CREATE:
		{
			for( int indx = 0, dy = 5; indx < SIZEOF(ctrlText); indx++ ) {
				CreateWindow( ctrlClass[indx], ctrlText[indx], WS_CHILD,
				              10,dy,220,20, hWnd, (HMENU)ctrlId[indx], hInst, NULL );
				dy += 30;
			}
			return 0;
		}
		case WM_DESTROY:
			PostQuitMessage(0);
			return 0;
		case WM_KEYUP:
		case WM_KILLFOCUS:
		case WM_LBUTTONUP:
			if( IsWindowVisible( GetDlgItem( hMainWnd, IDC_ACTIMEOUT ) ) )
				break;
			hideWnd();
			break;
		case WM_HSCROLL: {
			//if( (HWND)lParam == GetDlgItem( hMainWnd, IDC_ACTIMEOUT ) || (HWND)lParam == GetDlgItem( hMainWnd, IDC_BCTIMEOUT ))
			updateStatus();
			break;
		}
		case WM_COMMAND:
			switch( LOWORD( wParam ) ) {
				case IDC_APPLY:
				{
					g_dwAcTimeout = SendMessage( GetDlgItem( hMainWnd, IDC_ACTIMEOUT ), TBM_GETPOS, 0, 0 );
					g_dwBcTimeout = SendMessage( GetDlgItem( hMainWnd, IDC_BCTIMEOUT ), TBM_GETPOS, 0, 0 );
					HKEY key;
					if( RegOpenKeyEx( HKEY_CURRENT_USER, szAppReg, 0, 0, &key ) == ERROR_SUCCESS ) {
						RegSetValueEx( key, L"ACTimeout", NULL, REG_DWORD, (BYTE*)&g_dwAcTimeout, sizeof( g_dwAcTimeout ) );
						RegSetValueEx( key, L"BatteryTimeout", NULL, REG_DWORD, (BYTE*)&g_dwBcTimeout, sizeof( g_dwBcTimeout ) );
						RegCloseKey( key );
					}
				}
				case IDC_CANCEL:
					showSetup( FALSE );
					hideWnd();
					break;
				case IDC_EXIT:
					PostQuitMessage(0);
					return 0;
			}
			break;
		case WM_USER:
			showWnd();
			showSetup( TRUE );
			return 0;
	}
	return DefWindowProc(hWnd, message, wParam, lParam);
}

#define MSG_MAX_SIZE	(sizeof(POWER_BROADCAST)+sizeof(POWER_BROADCAST_POWER_INFO)+64)
DWORD xthread( void* )
{
	for(;;) {
		g_hQueue[1] = g_hev[EV_INACTIVE];
		if( WaitForMultipleObjects( 2, g_hQueue, FALSE, INFINITE ) == WAIT_OBJECT_0 )
			goto lbl_hide;
		g_hQueue[1] = g_hev[EV_ACTIVE];
		switch( WaitForMultipleObjects( 2, g_hQueue, FALSE, (g_bAC?g_dwAcTimeout:g_dwBcTimeout)*1000 ) ) {
			case WAIT_OBJECT_0:
				break;
			case WAIT_OBJECT_0+1:
				continue;
			case WAIT_TIMEOUT:
				showWnd();
				SwitchBacklight( VideoPowerOff );
				continue;
		}
lbl_hide:
		PPOWER_BROADCAST pb = (PPOWER_BROADCAST)alloca( MSG_MAX_SIZE );
		DWORD dw, dwFlags;

		ReadMsgQueue( g_hQueue[0], pb, MSG_MAX_SIZE, &dw, INFINITE, &dwFlags );
		if( dw >= sizeof(pb) && pb->Message == PBT_POWERINFOCHANGE ) {
			PPOWER_BROADCAST_POWER_INFO ppbpi = (PPOWER_BROADCAST_POWER_INFO)pb->SystemPowerState;
			g_bAC = ppbpi->bACLineStatus == 1;
		}

		hideWnd();
	}
}

int WINAPI WinMain(	HINSTANCE hInstance,
					HINSTANCE hPrevInstance,
					LPTSTR    lpCmdLine,
					int       nCmdShow)
{
	int indx;

	hInst = hInstance;

	g_hAtom = CreateMutex( NULL, FALSE, szAppAtom );
	if( GetLastError() == ERROR_ALREADY_EXISTS ) {
		PostMessage( FindWindow( szAppTag, szAppTitle ), WM_USER, 0, 0 );
		return -1;
	}

	ZeroMemory( g_hev, sizeof(g_hev) );
	for(indx = 0; indx < EV_COUNT; indx++ ) {
		g_hev[indx] = OpenEvent( EVENT_ALL_ACCESS, FALSE, g_szHev[indx] );
		if( g_hev[indx] == NULL ) {
			MessageBoxF(0, szAppTitle, MB_OK, L"%s event not found (%d)", g_szHevName[indx], GetLastError());
			goto lbl_cleanup;
	}	}

	{
		DWORD value;
		DWORD dw = sizeof(value);
		HKEY key;
		if( RegOpenKeyEx( HKEY_CURRENT_USER, szAppReg, 0, 0, &key ) == ERROR_SUCCESS ) {
			if( RegQueryValueEx( key, L"ACTimeout", NULL, NULL, (BYTE*)&value, &dw ) == ERROR_SUCCESS )
				g_dwAcTimeout = value;
			if( RegQueryValueEx( key, L"BatteryTimeout", NULL, NULL, (BYTE*)&value, &dw ) == ERROR_SUCCESS )
				g_dwBcTimeout = value;
		}
	}

	WNDCLASS	wc;

	ZeroMemory( &wc, sizeof(wc) );
    wc.lpfnWndProc		= (WNDPROC) WndProc;
    wc.hInstance		= hInstance;
    wc.lpszClassName	= szAppTag;
	wc.hbrBackground    = (HBRUSH)COLOR_WINDOW;

	if( !RegisterClass(&wc) ) {
		MessageBoxF(0, szAppTitle, MB_OK, L"Application startup failed(%d)", GetLastError());
		goto lbl_cleanup;
	}

	hMainWnd = CreateWindowEx( WS_EX_TOOLWINDOW, szAppTag, szAppTitle, WS_POPUP, 0, 0, 240, 320, NULL, NULL, hInstance, NULL );
	if( hMainWnd == NULL ) goto lbl_cleanup;

	MSGQUEUEOPTIONS opt;

	ZeroMemory( &opt, sizeof(opt) );
	opt.dwSize = sizeof(opt);
	opt.cbMaxMessage = MSG_MAX_SIZE;
	opt.bReadAccess = TRUE;

	g_hQueue[0] = CreateMsgQueue( NULL, &opt );
	if( g_hQueue[0] == NULL ) goto lbl_cleanup;
	if( !RequestPowerNotifications( g_hQueue[0], PBT_RESUME|PBT_POWERINFOCHANGE ) )
		MessageBoxF( NULL, szAppTitle, MB_OK, L"!RequestPowerNotifications: %d", GetLastError() );

	CreateThread( NULL, NULL, xthread, NULL, 0, NULL );

	MSG msg;
	while( GetMessage( &msg, NULL, 0, 0 ) ) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

lbl_cleanup:
	for(indx = 0; indx < EV_COUNT; indx++ ) {
		if( g_hev[indx] != NULL ) {
			CloseHandle( g_hev[indx] );
			g_hev[indx] = NULL;
		}
	}
	if( g_hAtom ) {
		CloseHandle( g_hAtom );
	}

	return 0;
}
